Description

Heads up: Playing some streams, the following for example will cause audacious to spew the following warning repeatedly every few
seconds due to (I presume) recent changes to ffaudio-core:

http://bbnmedia-lh.akamaihd.net/i/BibleBroadcasting_Englishios@87472/index_48 a-b.m3u8

NOTE: THIS stream must be added with the "M3U Playlist plugin" DEACTIVATED in order to play properly (another potential but
separate issue) else it will add but NOT play!

WARNING ffaudio-core.cc:186 [ffaudio_log_cb]: <(nil)> Using network protocols without global network initialization. Please use
avformat_network_init(), this will become mandatory later.

I'm not sure whether this "initialization" routine needs to be called once when the plugin is installed or should be repeated whenever a
song/stream that uses it starts to play? NOTE: there's also a corresponding "int avformat_network_deinit(void)" function as well. |
can research it further if you don't have time.

Regards,

Jim

History

#1 - April 22, 2018 19:26 - John Lindgren
A couple of things don't make sense. First, I'm not sure how you are opening an M3U playlist with the M3U plugin disabled. Second, Audacious
doesn't use (or shouldn't be using) any of FFmpeg's network support; all the /O should be going through our VFS layer and the neon plugin.

When | tried to play the linked playlist, the M3U plugin seemed to read the playlist fine, but MPG123 tried to play the audio files and produced
gibberish noise. Disabling MPG123 allowed the files to play (correctly) through ffaudio. HTTP I/O appeared to be routed through the neon plugin as
expected.

#2 - April 23,2018 02:11 - Jim Turner

Looks like it does the exact same thing for you that it does for me - playing correctly when opened w/o M3u plugin (as a unified stream), which is the
pbm: one must DISABLE m3u to open this (so-called) "m3u playlist"! Did you also get the warnings when playing correctly? Yes, it does go thru
neon either way as expected (and plays properly, if m3u doesn't get it's hands on it first), but w/these warnings.

#3 - April 23, 2018 02:18 - John Lindgren
No - | have the M3U playlist plugin enabled. | disabled MPG123 (the MP3 decoder).

#4 - April 23, 2018 21:00 - Jim Turner

- File 1000.audpl added
- File config added
http://bbnmedia-lh.akamaihd.net/i/BibleBroadcasting_Englishios@87472/index_48_a-b.m3u8

- File audacious_partial.dbg added

- File capture_window.1524515900.png added
- File capture_window.1524515893.png added
- File capture_window.1524515778.png added

Not sure we're on the same page. Here's some screenshots and logs showing what I'm doing. I'm using the latest Audacious GIT as/of 4/21 (NOT
Fauxdacious) In the screenshots the stream is playing correctly (with the warnings as shown). The "m3u" plugin is INACTIVE (as it MUST be, to play
correctly when first added). Let me know if you need any other info.

Jim

#5 - April 23, 2018 23:00 - John Lindgren

Let's resolve the issue of the M3U plugin first, because opening an M3U playlist without it is unsupported (I'm surprised that it's even possible).

What error do you get when you ENABLE the M3U plugin?

#6 - April 24, 2018 14:25 - Jim Turner
- File audacious_partial2.dbg added
- File capture_framedwindow.1524577374.png added

Ok. If I'm reading what you said in your original response, playing it with m3u plugin ENABLED, | get the same thing you did: 4 tiny streams added
and it plays the "gibberish" just as you described (like holding down the fast-forward button on an old VCR)! I'm attaching the screenshot of what it's
playing along with the pertinent parts of the debug (-VVV) info.

It appears to me that, at least in the case of THIS url, that it 1) needs ffaudio to play it instead of mp3, and 2) Though it's "m3u8", it must be
recognized and played as a single, continuous "stream", in which case the server returns (plays) a continuous (and contiguous) series of 10-second
AAC streams in series as a single, indefinite stream. That's why | believe (if m3u is not allowed to get it's hands on it and Audacious instead adds it
as a stream instead of a "playlist" and it correctly plays as such), Audacious probes it and ffaudio will then grab it and play it correctly as a single
continuous stream, which | believe is how the station's authors intend. The fix would likely not be trivial as Audacious would need to somehow
determine this whilst probing! If this is just a one-off "badly-behaving" playlist url, then this request should be rejected, but if other m3u8 streaming
stations are (starting to)? do things this way, it might be worth looking into adding some probing code to handle it (I'm assuming you are more
up-2-date knowledgewise on the direction that internet streaming is going than | am)!

Thanks!

Jim

#7 - April 24, 2018 19:50 - John Lindgren

This is the first time I've heard of using an M3U container to wrap a "stream" in 10-second segments. | would say that's using the wrong technology
for the job--other, better types of containers for streaming already exist.

I'm curious what FFmpeg is actually doing under the hood here. Is it sending a new HTTP request every 10 seconds for the next snippet? Or doing
some kind of black magic to open an actual (continuous) stream with a different URL and/or protocol?

From the little we know, it sounds like it would take a bit of work to support this type of streaming. It's not a project that | would personally want to
start on any time soon. Have you tried contacting the broadcasting station and asking them to provide a more standard streaming format as an
alternative?

#8 - April 24, 2018 22:26 - Jim Turner

Ok, if that's not proper for m3u8, then | wouldn't sweat it then, but I'll let you know if | start running into more of these, but please look at adding those
init()/deinit() functions to ffaudio, as | assume that if not addressed, a future ffaudio release will likely break things!

I bet it IS sending a req. every 10" or so since | get that "initialization" warning a/b that same frequency, which IS the main issue of the request here.
No, | haven't contacted them, since once | got it properly added into a saved playlist (initially, w/m3u turned off temporarily), it's been working fine
since then. Those warnings spam up the .xsession_errors file though, so if you can address them, then we could call it good for now | suppose! If
not, I'll eventually pbly. try to run that down and fix/test and eventually send a patch (for ffaudio).

Thanks,

Jim

#9 - June 30, 2018 02:09 - John Lindgren

- Status changed from New to Rejected

Closing as unsupported (the particular weird format, that is) for the time being.

#10 - September 23, 2019 20:45 - Jim Turner

UPDATE: John,

I think | have some new light to shed on this issue: This appears to be something called an "HLS" stream, aka "HTTP Live Streaming", and I'm
beginning to run into MORE of them now! | don't know if Audacious wants to support this or not, but I'm guessing you may be getting requests from
others on this in the future.

HTTP Live Streaming via .m3u8 "playlists": https:/en.wikipedia.org/wiki/HTTP_Live_Streaming

Regards,

Jim

Files

capture_window.1524515778.png 880 KB April 23, 2018 Jim Turner
capture_window.1524515893.png 1.37 MB April 23, 2018 Jim Turner
capture_window.1524515900.png 1.06 MB April 23, 2018 Jim Turner
audacious_partial.dbg 4.88 KB April 23, 2018 Jim Turner
config 336 Bytes April 23, 2018 Jim Turner
1000.audpl 183 Bytes April 23, 2018 Jim Turner
